from simtek_graphics import *
from numpy import *

# Simulation model
M = 1
x = zeros([M, 2])
v = zeros([M, 2])
u = zeros([2])
dt = 0.01
t = 0.0
radius = 1.0

# Initial values
u[0] = 0.0
u[1] = 1.0

init_graphics(x, radius, M)

# Freq?

def f(t, u):
  return array([u[1], -u[0]])

T = 10*2*pi

counter = 0
while(game.running and t < T):

  # Time-stepping
  t0 = t
  t = t + dt
  u0 = u
  for i in range(0, 5):
    fval = f(t, u)
    fval0 = f(t0, u0)
    u = u0 + 0.5 * dt * fval + 0.5 * dt * fval0

  # Output
  x = array([[0.0, u[0]]])
  v = array([[0.0, u[1]]])

  store(counter, t, x, v, fval)
  update_graphics(counter, x, dt)
  counter += 1

particle_plot(counter)
