from bisect import *
from pylab import *
# Did you remember to rename template.py to ode.py?
import ode

set_printoptions(3)

# Testcase for solve(). Scalar problem. 
# Expecting the function u(t) = exp(-t) and uarray[0, 2] == 0.81 with dt=0.1

def f(t, u): 
     return -u

[tarray, uarray] = ode.solve(f, [0, 2], 1, 0.1, "Euler")
print "u(2) = ", uarray[0,2]
figure(num=1)
plot(tarray, uarray[0])


## Testcase for solve(). Harmonic oscillator. 
def f_harmonic(t, u):
    return array([0, 0]) # Fill in implementation

I = [0.0, 20.0]
k = 0.1
u0 = array([1.0, 0.0])
[tarray, uarray] = ode.solve(f_harmonic, I, u0, k, "Euler")
figure(num=2)
plot(tarray, uarray[0], tarray, uarray[1])
show()


# Testcase for error estimate (5.5) 

u = ode.piecewise_linear_adapter(tarray, uarray)
dudt = ode.derivative_adapter(tarray, uarray)
R = ode.maximum_residual(tarray, u, dudt, f)


 
