from bisect import *
from pylab import *
import unittest
import ode as module


class Test_Module3(unittest.TestCase):

    # Test timestep
    def test_Timestepping_Question2_Subquestion1(self):
        def f1(t, u): return t*t
        def f2(t, u): return -u

        val1 = module.timestep(f1, 0.1, 1.0, 0.1, "Euler")
        ref1 = 1.001
        tol1 = 3

        val2 = module.timestep(f2, 0.1, 1.0, 0.1, "Euler")
        ref2 = 0.9
        tol2 = 3

        message = "Time-step with forward Euler too far from reference value. See unittest/moduletest.py for details. received: %f reference: %f correct number of decimals required: %f"

        self.assertAlmostEqual(val1,
                               ref1,
                               tol1,
                               message % (val1, ref1, tol1))

        self.assertAlmostEqual(val2,
                               ref2,
                               tol2,
                               message % (val2, ref2, tol2))

    # Test primitive
    def test_Solve_Question2_Subquestion2(self):

        def f1(t, u): return -u
        def f2(t, u): return array([u[1], -u[0]])

        [tarray1, uarray1] = module.solve(f1, [0, 4], 1, 0.01, "Euler")
        [tarray2, uarray2] = module.solve(f2, [0, 4], [1.0, 0.0], 0.01, \
                                              "Midpoint")

        val1 = uarray1[0, 2]
        ref1 = 0.9801
        tol1 = 3

        val2 = uarray2[0, 10]
        ref2 = 0.9950
        tol2 = 4

        message1 = "Solution with forward Euler too far from reference value. See unittest/moduletest.py for details. received: %f reference: %f correct number of decimals required: %f"

        message2 = "Solution with Midpoint/Trapezoid too far from reference value. See unittest/moduletest.py for details. received: %f reference: %f correct number of decimals required: %f"

        self.assertAlmostEqual(val2,
                               ref2,
                               tol2,
                               message2 % (val2, ref2, tol2))

unittest.main()
